



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>应用Apache Axis进行Web Service开发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">应用Apache Axis进行Web Service开发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:04:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自（http://tscjsj.blog.51cto.com/412451/84813）</p>
<h2><em>一、概述</em></h2>
<div>SOAP原意为Simple Object Access Protocol（简单对象访问协议），是一个用于分布式环境的、轻量级的、基于XML进行信息交换的通信协议（SOAP is an XML based protocol used to exchange information throughout a distributed environment）。</div>
<div>以下是w3c网站上的定义：</div>
<div>SOAP Version 1.2 (SOAP) is a lightweight protocol intended for exchanging structured information in a decentralized, distributed environment. It uses XML technologies to define an extensible messaging framework providing a message construct that can be exchanged over a variety of underlying protocols. The framework has been designed to be independent of any particular programming model and other implementation specific semantics.</div>
<div>可以认为SOAP是XML-RPC的高级版本，二者基于相同的原理：利用HTTP + XML封装进行RPC调用。</div>
<div>SOAP最初由MS发起研究，用以解决MTS/COM资源消耗大，不够轻巧等问题，后逐渐被IBM等巨头接纳并加入研究，现已提交W3C，成为Web Service应用传输标准。对于轻量级、可扩展Web Service应用协议的需求促成了SOAP的广泛应用，也间接促进了XML的流行。关于相关历史的更多信息，见<a href="http://www.microsoft.com/china/MSDN/library/WebServices/WebServices/SOAPSpecificationIndexPage.mspx" rel="external nofollow noreferrer">[url]http://www.microsoft.com/china/MSDN/library/WebServices/WebServices/SOAPSpecificationIndexPage.mspx[/url]</a>或<a href="http://www-128.ibm.com/developerworks/cn/webservices/ws-ref1/index.html" rel="external nofollow noreferrer">[url]http://www-128.ibm.com/developerworks/cn/webservices/ws-ref1/index.html[/url]</a>。</div>
<h2><em>二、SOAP数据包结构解析</em></h2>
<div>SOAP的消息被称为一个SOAP Envelope，包括SOAP Header和SOAP Body。其中，SOAP Header可以方便的插入各种其它消息来扩充Web Service的功能，比如Security（采用证书访问Web Service），SOAP Body则是具体的消息正文，也就是Marshall后的信息。</div>
<div>SOAP调用的时候，也就是向一个URL（比如<a href="http://api.google.com/search/beta2" rel="external nofollow noreferrer">[url]http://api.google.com/search/beta2[/url]</a>）发送HTTP Post报文（根据SOAP规范，HTTP Get报文也可被支持），调用方法的名字在HTTP Request Header SOAP-Action中给出，接下来就是SOAP Envelope了。服务端接到请求，执行计算，将返回结果Marshall成XML，用HTTP返回给客户端。</div>
<div>以下是一个典型的SOAP数据包：</div>
<div>&nbsp;</div>
<div>
<div>&lt;s:Envelope&nbsp;xmlns:s="http://www.w3.org/2003/05/soap-envelope"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;s:Header&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;m:transaction&nbsp;xmlns:m="soap-transaction"&nbsp;s:mustUnderstand="true"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;transactionID&gt;1234&lt;/transactionID&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/m:transaction&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/s:Header&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;s:Body&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;n:purchaseOrder&nbsp;xmlns:n="urn:OrderService"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;from&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;person&gt;Christopher Robin&lt;/person&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;dept&gt;Accounting&lt;/dept&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/from&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;to&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;person&gt;Pooh Bear&lt;/person&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;dept&gt;Honey&lt;/dept&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/to&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;order&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;quantity&gt;1&lt;/quantity&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;item&gt;Pooh Stick&lt;/item&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/order&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/n:purchaseOrder&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/s:Body&gt;&nbsp;<br /><br />&lt;/s:Envelope&gt;&nbsp;</div>
</div>
<div>
<div>&nbsp;</div>
<p>其中包含了一些SOAP规范定义的标签，同时也可以包含一些具体应用相关的标签。</p></div>
<div>Note:</div>
<div>如果你是一个普通的应用开发者，以上介绍已经足够了，因为相应的SOAP应用平台会负责完成相应SOAP数据包的打包和解析；如果你是一个SOAP应用平台的实现者，关于SOAP基础理论的更多介绍可参考《Programming Web Services with SOAP》一书或SOAP Specification（[url]http://www.w3.org/TR/soap12-part0/[/url]）。</div>
<h2><em>三、安装Apache Axis</em></h2>
<div>Apache Axis本身也是一个Web Project，它内建了对SOAP的编码、解析，并为Client提供了一些使用SOAP Service的API，同时，为Web Service的发布提供管理，并对Client提交的处理请求作出响应。对于基于Axis的应用而言，我们可以将注意力完全放在具体Service和Client的设计上，而无需考虑中间的传输过程（对于Client而言，还需要使用一些Axis提供的访问SOAP服务的特定API），这一点是与XML RPC不同的地方。</div>
<div>Apache Axis可以从<a href="http://ws.apache.org/axis/" rel="external nofollow noreferrer">[url]http://ws.apache.org/axis/[/url]</a>下载，当前的最新版本是1.4。</div>
<div>安装Axis的过程很简单：</div>
<div>1、解压Axis到任意目录下；</div>
<div>2、拷贝Axis目录下的webapps/axis目录到%TOMCAT_HOME%/webapps下；</div>
<div>3、为了便于编译和测试程序，添加环境变量:</div>
<div>AXIS_HOME&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Axis的解压目录</div>
<div>AXIS_LIB&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%AXIS_HOME%/lib</div>
<div>AXISCLASSPATH&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%AXIS_LIB%\axis.jar;%AXIS_LIB%\commons-discovery-0.2.jar;%AXIS_LIB%\commons-logging-1.0.4.jar;%AXIS_LIB%\jaxrpc.jar;%AXIS_LIB%\saaj.jar;%AXIS_LIB%\log4j-1.2.8.jar</div>
<div>完成上述工作后，启动Tomcat，并用IE打开：<a href="http://localhost:8080/axis/" rel="external nofollow noreferrer">[url]http://localhost:8080/axis/[/url]</a>，点击其中的Validation、List两个链接，如果没有报告任何错误，则说明Axis安装成功。</div>
<div>关于Apache Axis安装的更多信息可以参考官方文档：<a href="http://ws.apache.org/axis/java/install.pdf" rel="external nofollow noreferrer">[url]http://ws.apache.org/axis/java/install.pdf[/url]</a>。</div>
<h2><em>四、举例</em></h2>
<div>有了上面对SOAP的基本理解，下面我们体验一下Apache Axis 1.4提供的SOAP服务。</div>
<div>以下面EchoService为例：</div>
<div>&nbsp;</div>
<div>
<div>public&nbsp;class&nbsp;EchoService {&nbsp;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;String echoString(String name) {&nbsp;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;name;&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;&nbsp;<br /><br />}</div>
</div>
<div>其对应的Client程序如下所示：</div>
<div>&nbsp;</div>
<div>
<div>package&nbsp;demo.soap;&nbsp;<br>import&nbsp;org.apache.axis.client.Call;&nbsp;<br>import&nbsp;org.apache.axis.client.Service;&nbsp;<br>import&nbsp;javax.xml.namespace.QName;&nbsp;<br /><br />public&nbsp;class&nbsp;EchoClient {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;static&nbsp;void&nbsp;main(String [] args) {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;try&nbsp;{&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String endpoint =&nbsp;"http://localhost:8080/axis/EchoService.jws";&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// Create Service and Call object to set up a SOAP RPC&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Service service =&nbsp;new&nbsp;Service();&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Call call = (Call)service.createCall();&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// Tells which service and method will be invoked&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;call.setTargetEndpointAddress(new&nbsp;java.net.URL(endpoint));&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;call.setOperationName(new&nbsp;QName("echoString"));&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// Invoke method with required parameters&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String ret = (String)call.invoke(new&nbsp;Object[] {&nbsp;"Hello!"&nbsp;});&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println("Sent 'Hello!', got '"&nbsp;+ ret +&nbsp;"'");&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;catch&nbsp;(Exception e) {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.err.println(e.toString());&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br /><br />}&nbsp;<br /><br /></div>
</div>
<div>对于Client程序而言，对Axis Service进行访问的基本方法是：</div>
<div>1、创建Service及Call对象；</div>
<div>2、设置Call对象属性，如访问点（标明将访问哪个Axis Service）及方法名等；</div>
<div>3、传入参数数组，调用Call对象的invoke方法。</div>
<div>可使用如下命令编译EchoClient.java：</div>
<div>javac -cp %AXISCLASSPATH% EchoClient.java</div>
<div>在Axis中，存在两种发布SOAP Service的方法。</div>
<div>方法一：</div>
<div>将源程序EchoService.java拷贝到%TOMCAT_HOME%/webapps/axis下，并将其后缀改为.jws即可。</div>
<div>第一种方法非常的简单，但是第一种发布方法存在几个重要的限制：</div>
<div>1、不能指定package；</div>
<div>2、需要有Service的源码；</div>
<div>因此常常不能满足我们的需要。</div>
<div>方法二：</div>
<div>第二种发布Axis Service的方法需通过配置来完成。</div>
<div>以下面的HelloService为例（与前面的EchoService基本没有什么区别，但其中使用了package）：</div>
<div>&nbsp;</div>
<div>
<div>package&nbsp;demo.soap;&nbsp;<br /><br />public&nbsp;class&nbsp;HelloService {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;String sayHello() {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;"Hello World!";&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br /><br />}&nbsp;</div>
</div>
<div>&nbsp;</div>
<div>要发布上面的Service，需编写如下的配置文件：</div>
<div>&nbsp;</div>
<div>
<div>&lt;deployment&nbsp;xmlns="http://xml.apache.org/axis/wsdd/"&nbsp;xmlns:java="http://xml.apache.org/axis/wsdd/providers/java"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;service&nbsp;name="HelloService"&nbsp;provider="java:RPC"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;parameter&nbsp;name="className"&nbsp;value="demo.soap.HelloService"/&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;parameter&nbsp;name="allowedMethods"&nbsp;value="*"/&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/service&gt;&nbsp;<br /><br />&lt;/deployment&gt;&nbsp;</div>
</div>
<div>
<div>&nbsp;</div>
<p>将上述内容保存为%TOMCAT_HOME%\webapps\axis\WEB-INF\deploy.txt，并在其所在目录下执行：</p></div>
<div>java -cp %AXISCLASSPATH% org.apache.axis.client.AdminClient deploy.txt</div>
<div>生成server-config.wsdd文件，打开该文件看一下，可以看到HelloService的相关信息已被添加到该文件，此外，还包括一些默认的配置信息以及AdminService、Version两个基础服务。</div>
<div>以下是HelloService的Client程序的相关代码：</div>
<div>&nbsp;</div>
<div>
<div>
<div>package&nbsp;demo.soap;&nbsp;<br>import&nbsp;org.apache.axis.client.Call;&nbsp;<br>import&nbsp;org.apache.axis.client.Service;&nbsp;<br /><br />public&nbsp;class&nbsp;HelloClient {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public&nbsp;static&nbsp;void&nbsp;main(String [] args)&nbsp;throws&nbsp;Exception {&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String endpoint =&nbsp;"http://localhost:" + "8080" + "/axis/services/HelloService"; // Attention: A little difference&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Service service =&nbsp;new&nbsp;Service();&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Call call = (Call)service.createCall();&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;call.setTargetEndpointAddress(new&nbsp;java.net.URL(endpoint));&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;call.setOperationName("sayHello");&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String res = (String)call.invoke(new&nbsp;Object[] {});&nbsp;</div>
<div><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(res);&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}&nbsp;<br /><br />}&nbsp;<br></div>
</div>
</div>
<div>
<div>&nbsp;</div>
<p>与前面的EchoClient的区别仅在于访问点稍有不同。</p></div>
<div>发布后如何删除对应的Service呢？要删除上面发布的HelloService服务，只需在%TOMCAT_HOME%\webapps\axis\WEB-INF目录下添加如下的undeploy.txt描述文件，其内容如下：</div>
<div>&nbsp;</div>
<div>
<div>&lt;undeployment&nbsp;xmlns="http://xml.apache.org/axis/wsdd/"&gt;&nbsp;<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;service&nbsp;name="HelloService"/&gt;&nbsp;<br /><br />&lt;/undeployment&gt;&nbsp;</div>
</div>
<div>然后执行：</div>
<div>java -cp %AXISCLASSPATH% org.apache.axis.client.AdminClient deploy.txt</div>
<div>以更新server-config.wsdd文件。</div>
<div><a href="http://localhost:8080/axis/servlet/AxisServlet" rel="external nofollow noreferrer">[url]http://localhost:8080/axis/servlet/AxisServlet[/url]</a></div>
<div>将看到前面已发布的对应的Service已被删除。</div>
<div>如果以后还要发布新的Service，你可以选择直接更新上面产生的server-config.wsdd文件，或者重复上面的步骤。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zdee9.html">iOS开发常用校验</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnv4o28.html">Python 模块学习：os模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvrmmj8.html">LB负载均衡之Nginx-Proxy</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx3w5jq.html">ubuntu16&period;04解决播放swf视频文件问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmkgoe9.html">STL总结之functor</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2yk09.html">Codeforces  14D</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4xrzq.html">一般处理程序、ASP&period;NET核心知识（5）--转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mng4p2q.html">怎样调通微信支付及微信发货通知接口（Js API）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjr0rr8.html">routeProvider路由的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoe50xq.html">java的基本知识导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglpx48.html">谷歌面试题：输入是两个整数数组，他们任意两个数的和又可以组成一个数组，求这个和中前k个数怎么做？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrpxn9.html">并发编程（一）&mdash;&mdash; volatile关键字和 atomic包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2nknpq.html">Bartender标签传参与打印</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ww73nq.html">吴恩达机器学习笔记21-正则化线性回归&lpar;Regularized Linear Regression&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r326n9.html">JAVA 面向对象中的多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwy6px9.html">weblogic相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp3myk9.html">Where is virtualenvwrapper&period;sh after pip install&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/963k4gj9.html">python网络编程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn33meq.html">RabbitMQ概念及环境搭建（四）RabbitMQ High Availability</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mo3748.html">&dollar;&period;ajax 的速度要快于 angular 里 &dollar;http  &lpar;个别情况&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j22w85.html">&lpar;整理&rpar;MyBatis入门教程（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ejne91.html">Princeton Algorithms week3 Assignment</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pgnk9x.html">使用CocosSharp制作一个游戏 - CocosSharp中文教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1yp2qg.html">Floyd-Warshall 全源最短路径算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy6ej8r.html">EasyPR--开发详解（7）字符分割</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy0ym8r.html">转-基于NodeJS的14款Web框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv3p18x.html">CSharpGL&lpar;14&rpar;用geometry shader渲染模型的法线&lpar;normal&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx61qo.html">推荐一个不错的在线制图网站---ProcessOn</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mvjp8k.html">06&period; Web大前端时代之：HTML5&plus;CSS3入门系列~HTML5 画布</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvm3yqx.html">跟我学习NHibernate &lpar;1&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
